Revision History for dtd.pl
-----------------------------

Thanks to all who found the bugs, or who's comments lead me to finding
the bugs.  And thanks for feedback that modified functionality.

Special thanks to,

    harward@convex.com (Ken Harward)
    savela@tel.vtt.fi (Markku Savela)
    glv@utdallas.edu (Glenn Vanderburg)
    connolly@hal.com (Daniel W. Connolly)
    schampeo@aisg.com (Steven Champeon)

for finding bugs and giving comments.

Sorry if I left someone out.


=============================================================================
2.0.0	(May 31, 1994)

    New Functionality/Enhancements:

	o NOTATION declarations are recognized.  They're stored in the
	  %PubNotation (PUBLIC) and %SysNotation (SYSTEM) arrays.

	o Support for a comment callback.  I.e. a Perl program can
	  register a callback function (with DTDset_comment_callback)
	  inorder to extract the text within comment declarations.

	o Support for processing instructions.  A callback can be
	  registered (with DTDset_pi_callback) to be invoked when a
	  processing instruction is encountered.

	o Added a verbosity mode (with DTDset_verbosity).  If set,
	  messages are outputed to STDERR giving status on what
	  DTDread_dtd is parsing.  This is mainly for debugging
	  purposes.

	o Better support for marked sections.  RCDATA and CDATA
	  marked sections are explicitly ignored (due to no DTD
	  markup in them), and multiple keywords are handled.

	o Added a few more utility routines:

		DTDget_base_children
		DTDget_exc_children
		DTDget_inc_children
		DTDis_occur_indicator
		DTDis_group_connector
		DTDis_tag_name

	o Rewrote DTDprint_tree routine.  It does two passes on an
	  elements content hierachy to perform maximum pruning.  The
	  first pass computes the highest level of each element, and
	  the second pass prints the tree, pruning based on the
	  data from the first pass.


    Bug Fixes:

	o Fixed bug in get_next_group() function.  Cases occurred when
	  it would not grab an occurance operator in a model group.  This
	  problem caused invalid data being stored for elements.
	  (I do not know why this problem did not show up earlier)

	o Properly recognized attributes with the NOTATION declared
	  value keyword.  Before, an attribute list with a NOTATION
	  value will cause errors in parsing the attlist.

	o Multiple concurrent open external file references are handled.
	  I.e. A DTD that references a file (via parameter entity)
	  and that file references a file, and so on ... is handle
	  correctly.  Before, only one external file reference could
	  be active at a given time.

	o Attribute names are stored in lowercase.  This is analogous
	  to how element names are stored.  Before, they were stored
	  in the case they appeared in the DTD.

	o Recognizes lowercase declaration type keywords.  I.e.
	  Before, the declaration, "<!entity ...", would not
	  have been recognized.

	o Fixed other spots in code where lowercase versions of
	  SGML keywords were not recognized.

	o Fixed a STUPID goof on my part where I misspelled
	  'declaration'.  I was spelling it 'decleration'.  Some
	  internal routines had this word as part of their name, or
	  the word was used within routines.  At least I was consistant
	  in my misspelling.



=============================================================================
1.1.0	(May 19, 1994)

    New Functionality/Enhancements:

	o General entities are supported, however, external ones are
	  still ignored (needed for IBMIDDoc).

	o General entities are expanded when found in the DTD.
	  I.e. General entities are not expanded when found in a parameter
	  entity definition, but are expanded when the parameter entity is
	  referenced (needed for IBMIDDoc).

    Bug Fixes:

	o The #FIXED default value of an attribute is recognized.

	o <!ATTLIST #NOTATION is ignored properly.

	o Putting parenthesis around an external parameter entity reference
	  could have cause element names to be stored with a parenthesis.
	  This has been fixed.

	o Fixed bug in parsing string values.

	o Semi-colons were missing in some Perl statements that
	  caused older Perl interpreters to complain.

	o Recognizes a parameter enitity being used to define an element's
	  tag minimization.


=============================================================================
1.0.0	(May 12, 1994)

    The original version (no version number was given out when this
    was released).
